#include <stdio.h>
#include <iostream>

using namespace std;

int main() {
    int n, o, a, b, ab;
    cin>>n>>o>>a>>b>>ab;
    string pacTip[n];
    int pacBr[n], trebaO[n], trebaA[n], trebaB[n], trebaAB[n];
    for (int i=0; i<n; i++){
        trebaO[i]=0;
        trebaA[i]=0;
        trebaB[i]=0;
        trebaAB[i]=0;
    }
    for (int i=0; i<n; i++) cin>>pacTip[i]>>pacBr[i];

    for(int i=0; i<n; i++){
        if(pacTip[i]=="O"){
            if(pacBr[i]<=o){
                trebaO[i]+=pacBr[i];
                o-=pacBr[i];
            }

            else{
                cout<<"nemoguce";
                return 0;
            }
        }
    }

    for(int i=0; i<n; i++){
        if(pacTip[i]=="A"){
            if(pacBr[i]<=a){
                trebaA[i]+=pacBr[i];
                a-=pacBr[i];
            }

            else if(pacBr[i]<=(a+o)){
                trebaA[i]+=a;
                trebaO[i]+=pacBr[i]-a;
                a=0;
                o-=trebaO[i];
            }

            else{
                cout<<"nemoguce";
                return 0;
            }
        }
    }

    for(int i=0; i<n; i++){
        if(pacTip[i]=="B"){
            if(pacBr[i]<=b){
                trebaB[i]+=pacBr[i];
                b-=pacBr[i];
            }

            else if(pacBr[i]<=(b+o)){
                trebaB[i]+=b;
                trebaO[i]+=pacBr[i]-b;
                b=0;
                o-=trebaO[i];
            }


            else{
                cout<<"nemoguce";
                return 0;
            }
        }
    }

    for(int i=0; i<n; i++){
        if(pacTip[i]=="AB"){
            if(pacBr[i]<=a){
                trebaA[i]+=pacBr[i];
                a-=pacBr[i];
            }

            else if(pacBr[i]<=(a+b)){
                trebaA[i]+=a;
                trebaB[i]+=pacBr[i]-a;
                a=0;
                b-=trebaB[i];
            }

            else if(pacBr[i]<=(a+b+o)){
                trebaA[i]+=a;
                trebaB[i]+=b;
                trebaO[i]+=pacBr[i]-a-b;
                a=0;
                b=0;
                o-=trebaO[i];
            }

            else if(pacBr[i]<=(a+b+o+ab)){
                trebaA[i]+=a;
                trebaB[i]+=b;
                trebaO[i]+=o;
                trebaAB[i]+=pacBr[i]-a-b-o;
                a=0;
                b=0;
                o=0;
                ab-=trebaAB[i];
            }

            else{
                cout<<"nemoguce";
                return 0;
            }
        }
    }

    cout<<"moguce"<<endl;
    for (int i=0; i<n; i++) cout<<trebaO[i]<<" "<<trebaA[i]<<" "<<trebaB[i]<<" "<<trebaAB[i]<<endl;
    return 0;
}